+ новая возможность
- исправление ошибки
! изменение или исправление, которое может повлиять на работу соответствующих подсистем и требуется тщательное тестирование

  AM 5.2
-----------------------------------------------------------------
--- 5.2.472 --- 01.07.2025
+ [283599] am --password-file file возсожность задать пароль в файле, который потом можно будет использовать в pha.conf для ldap.auth.password_file и в db.conf для password_file вместо параметра password

--- 5.2.471 --- 21.05.2025
- [282393] Исправлена работа параметра use_persistent_sessions в am.ini, убрана информация о параметрах jwt_source и jwt_keys_dir, работающих только в pha.conf

--- 5.2.470 --- 14.05.2025
- [273295] Исправлено отсутствие вывода помощи при запуске с аргументом --help на Linux
+ [279721] Добавлена информация о параметрах агента jwt_source, jwt_keys_dir и
use_persistent_sessions при старте с аргументом '--help'

--- 5.2.469 --- 24.03.2025
- [279792] Порт для подключения агентов теперь слушается только на localhost

--- 5.2.467 --- 11.02.2025
- [277389] Ошибки запуска агента в браузере нечитаемы

--- 5.2.466 --- 20.12.2024
+ [273954] возможность загрузки jre и очистки недоудаленных файлов
+ [272981] возможность узнавать имена типов в runtime

--- 5.2.465 --- 08.11.2024
+ [271607] прерход на xxhash при проверке целостности
- [263173] #fsert Фаззинг: исправлен некорректный сбор покрытия для
           персистентных фаззинговых кампаний

--- 5.2.464 --- 27.08.2024
- [267206] #fsert Сообщение диагностики: BUFFER_OVERLAP adt_array.cpp BUFFER_UNDERFLOW agent_unix.cpp DIVISION_BY_ZERO agent.cpp INTEGER_OVERFLOW adt_unix.cpp
- [267151] #fsert Сообщение диагностики: BUFFER_OVERLAP adt_array.cpp STATIC_OVERFLOW.LOCAL adt_taggedio.cpp STATIC_OVERFLOW.SPRINTF adt_log.cpp DEREF_OF_NULL.RET.LIB smtp.cpp
  NO_CAST.INTEGER_OVERFLOW rq_agentInfo.h NO_CAST.INTEGER_OVERFLOW ini.cpp NO_CAST.INTEGER_OVERFLOW sched.cpp NO_EFFECT.MACRO adt_array.cpp SIMILAR_BRANCHES rq_startStopAgent.h UNINIT_HEAP.CCTOR adt_hash.h

--- 5.2.463 --- 17.07.2024
- [266102] учет пробелов в пути к исполняемым файлам

--- 5.2.462 --- 04.06.2024
+ [263177] Фаззинг: добавлен сбор покрытия
+ [262971] писать лог в кодировке utf8

--- 5.2.461 --- 23.04.2024
+ [262715] замена механизма формирования стеков вызова libdwarf на libdw
- [262715] Сообщение диагностики: client.cpp DEREF_OF_NULL.DYN_CAST; smtp.cpp xmpp.cpp  NONTERMINATED_STRING.STYLE; server.cpp DIVISION_BY_ZERO.EX; adt_fileio_unix.cpp NEGATIVE_CODE_ERROR.EX;
       agent.cpp NULL_AFTER_DEREF UNINIT.CTOR UNCHECKED_FUNC_RES.STAT; adt_unix.cpp UNCHECKED_FUNC_RES.STAT; rq_mail.h rq_updates.h UNINIT.CTOR; service_unix.cpp HANDLE_LEAK
+ [261643] Фаззинг: добавлены цели для фаззинг-тестирования ini-конфига и http порта, клиентского порта и порта агента
- [262515] Фаззинг: Исправление buffer-overflow при парсинге расписания
- [262509] Фаззинг: Исправление buffer-overflow при парсинге маски подсети
- [262438] Диагностика warning: loop variable 'w' creates a copy
- [262852] UB в adt::MemoryBuffer

--- 5.2.460 --- 23.11.2023
- minor fixes

--- 5.2.459 --- 13.10.2023
- Параметр агента location не передавался в amconsole
+ Описание интеграции с AD вынесено в отдельный файл doc/asmo-ad.adoc
+ Описание установки под linuxc doc/asmo-install.adoc
- исправлена документация
+ Дистрибутив msi включает jre

--- 5.2.458 --- 18.09.2023
- [252526] Добавление больше пояснений к asmo-linux. Изменение формата файла на ADOC, смена кодировки с Win1251 на UTF8
+ http запрос /debug

--- 5.2.457 --- 08.09.2023
- [250597] некорректная кодировка в описании продукта при подписовании кода
+ рефакторинг замена adt::Vector на adt::Array

--- 5.2.456 --- 01.09.2023
- в пути для агентов добавляется / в конце
+ Ответ на запроc /robots.txt запрещающий индексацию сайта

--- 5.2.453 --- 31.08.2023
- Неправильно выполнялась фильтрация по списку агентов

--- 5.2.452 --- 31.08.2023
+ Параметр агента location
- Обработка http заголовка Host и фильтрация по агентам
+ Обработка http заголовка X-Asmo-Web-Root (можно задать из nginx)

--- 5.2.451 --- 22.08.2023
- исправлена ошибка загрузки обновлений (появилось в 5.2.450)

--- 5.2.450 --- 21.08.2023
+ [199557] установка лиензии на сервер через amconsole v6
- Увеличен праметр backlog до 64 для вызова listen

--- 5.2.444 --- 20.06.2023
- minor fix

--- 5.2.442 --- 28.03.2023
- [201420] АСМО-микросервис конвертирования: при импорте vsd схемы вылезает диалоговое окно.
- [201408] АСМО-микросервис конвертирования: запрашивает включить или отключить макросы схемы
- [201424] АСМО-микросервис конвертирования: через некоторое количество импортов ошибка таблица "MTD_TREE" не найдена

--- 5.2.441 --- 20.03.2023
- [201212] Конвертер vsd порт микросервиса 4999, порт взаимодействия с агентом 4998

--- 5.2.440 --- 16.03.2023
- [201223] АСМО-микросервис конвертирования. Нет всплывающей подсказки у значка сервиса в панели задач
- [201212] Конвертер vsd порт микросервиса 4999

--- 5.2.439 --- 10.03.2023
+ [200354] само-проверка совместимая с подписыванием кода
+ [198480] возможность запуска в трее

--- 5.2.438 --- 14.12.2022
- [197907] не учитывать web-сессии в количестве клиентов при показе в asmconsole
- [198321] дополнительная диагностика расписания презапуска агентов
- [198321] не срабатывает расписание презапуска агентов

--- 5.2.437 --- 01.12.2022
+ [197274] описание базы в окне подключения тонкого web-клиента

--- 5.2.436 --- 26.10.2022
- неправильная кодировка в http ответах

--- 5.2.435 --- 20.10.2022
+ [196516] разделение баз по хостам при подключении к серверу приложений

--- 5.2.434 --- 12.10.2022
- [196507] улучшен алгоритм перезапуска агентов по расписанию

--- 5.2.433 --- 27.09.2022
+ doc описание AD-аутентификации в linux

--- 5.2.432 --- 02.08.2022
+ [194630] restart_time теперь воздействует на агент как остановка из amconsole - закрытие агента с ожиданием отсутствия активности не более 5-ти минут

--- 5.2.431 --- 28.04.2022
- [192014] - +Inf при вычислении времени сборки мусора

--- 5.2.430 --- 30.03.2022
+ [189102] диагностика некорректного изменения am.ini через amconsole - уникальность имени, ид портов агента

--- 5.2.422 --- 11.03.2022
- [189471] сообщения, отправленные пользователям сервера через amconsole, приходят в плохой кодировке

--- 5.2.421 --- 07.12.2021
+ [187603] возможность задать полный адрес сервера в параметре fqdn файла am.ini

--- 5.2.420 --- 02.12.2021
- [187459] диагностика принудительной остановки агента

--- 5.2.419 --- 17.11.2021
- [187157] не передается http/https-порт для агентов с параллельными worker_processes процессами, если пользователь подключен не к первому процессу агента

--- 5.2.418 --- 10.08.2021
- [184397] при ошибке подключения Transport endpoint is not connected (107) пересоздавать входящее подключение

--- 5.2.417 --- 29.06.2021
- [183392] в версии windows при страте агента с ошибкой теряется кодировка при чтении лога агента из консоли

--- 5.2.416 --- 15.06.2021
- [182743] хелп в командной строке по насторойке restart_time

--- 5.2.415 --- 02.06.2021
+ [182743] настройка агента restart_time=HH1:MM1;HH2:MM2;... в am.ini для планирования времени перезапуска агнета

--- 5.2.414 --- 21.05.2021
- [182197] некорректно передается xmpp-сообщение

--- 5.2.413 --- 17.05.2021
- [182135] некорректно передается имя агента в командную строку агента

--- 5.2.412 --- 14.05.2021
! [174270] переход на utf8

--- 5.2.408 --- 09.02.2021
- [179617] восстановлена кодировка файла agent.h с utf-8 на 1251

--- 5.2.407 --- 14.01.2021
+ [159975] запрос на проверку аутентификации AD

--- 5.2.406 --- 29.06.2020
- [174844] Не показываются пользователи

--- 5.2.405 --- 10.06.2020
+ [174262] сборка с проверкой целостности под linux
- сборка без зависимостей на libstdc++.so.6 и libgcc_s.so.1 в linux
- fix gcc warnings

--- 5.2.404 --- 28.04.2020
+ [172691] при получении списка агентов возвращать количество подключений к бд, % использования памяти, резидентная память, память свопа, время запуска

--- 5.2.403 --- 10.12.2019
+ [167744] при получении списка обновлений возвращать даты файлов

--- 5.2.402 --- 30.10.2019
- проверка обновления
- новый формат имен

--- 5.2.401 --- 29.10.2019
+ [167288] указывать тип ОС при запросе списка обновлений
+ обновилась документация
+ [167641] поддержка нового формата имен агентов  linux-x64/windows

--- 5.2.400 --- 12.09.2019
- [158880] под linux было возможно появление процессов зомби
- utf8 fix

--- 5.2.324 --- 13.12.2017
+ [148177] юнит для systemd и описание установки

--- 5.2.322 --- 19.10.2017
+ [146597] linux: Возможность работы на серверах с glibc < 2.14

--- 5.2.321 --- 22.08.2017
+ [143493] client_ports - у агента, client_ports - у am распределяется у всех агентов, где явно не заданы номера

--- 5.2.320 --- 04.05.2017
+ [141465] amconsole показывать session_id и agentInstanceID

--- 5.2.318 --- 25.04.2017
+ [139142] передача номера параллельного агента при запуске агента
- неправильное получение списка агентов

--- 5.2.316 --- 19.04.2017
- [140985] переиспользовать номера параллельных агентов, показывать их в amconsole, возможность подключения клиента по этому номеру
- [140968] при невозможности открыть http порт делать еще несколько попыток через небольшой интервал времени
- [140964] не правильный показ heavy агентов в amconsole

--- 5.2.315 --- 14.04.2017
- неправильное определение настройки heavy_processes

--- 5.2.314 --- 14.04.2017
- [139762] возможность запуска конкретного процесса агента, если настроено несколько процессов в агенте

--- 5.2.313 --- 05.04.2017
+ [139968] время cpu в телеметрии
+ [139486] perf: перебалансировка клиентов

--- 5.2.312 --- 30.03.2017
+ [139141] perf: балансировка клиентов

--- 5.2.311 --- 24.03.2017
+ [139544] pid агента в amconsole
+ [139545] java heap/max heap в amconsole
+ [139546] телеметрия в amconsole

--- 5.2.309 --- 16.03.2017
+ [139140] perf: показатели am для алгоритма балансировки

--- 5.2.308 --- 05.03.2017
- [138934] в linux неправильно определялось потребление CPU агентом

--- 5.2.306 --- 26.02.2017
+ [137999] perf: Запуск агента в несколько процессов worker_processes в am.ini

--- 5.2.305 --- 30.01.2017
+ [137462] контроль целостности менеджера агентов под linux

--- 5.2.304 --- 23.01.2017
+ [136723] Вывод полноценного callstack при ошибках в linux
- [137620] более понятное отображение времени запроса в am.perf
+ [137075] возможность редактировать db.conf в amconsole

--- 5.2.303 --- 19.12.2016
- [136634] улучшена диагностика ошибки Transport endpoint is not connected
- Запись в лог для linux версии завершается символами \r\n аналогично windows версии

--- 5.2.302 --- 29.11.2016
- у некоторых выполненных запросов постоянно увеличивается hang time
- [136015] увеличено хранение выполненных задач до 1024 шт

--- 5.2.301 --- 26.11.2016
+ [135845] возможность просмотра последних уже выполненных задач

--- 5.2.300 --- 25.11.2016
+ [135614] возможность отключить всех пользователей агента
+ [119138] диагностика долгой сборки мусора должна включать список выполняемых запросов, запись в лог(am.perf.log)

--- 5.2.109 --- 24.10.2016
+ [133503] улучшена диагностика ошибок типа AccessViolation

--- 5.2.108 --- 30.06.2016
! [130360] conf: использование pha.conf вместо pha32.conf и pha64.conf (файлы pha32.conf и pha64.conf всё ещё читаются, для совместимости, при отсутствии файла pha.conf)
- [130214] автоматизированное обновление: не удалялись .uploading-файлы, при ошибке переименования загруженного файла
+ [130214] автоматизированное обновление: очистка каталога распакованных обновлений после загрузки zip-архива
+ [130214] автоматизированное обновление: запрет на удаление используемых версий zip-архивов
+ [130360] pha.conf: возможность редактирования через amconsole

--- 5.2.107 --- 20.06.2016
- [126005] перестали нормально работать агенты, настроенные через cmd
- [130215] web linux: не работала передача слушающего сокета в агент

--- 5.2.106 --- 30.05.2016
! [126005] автоматизированное обновление: перезапуск агентов только, если обновление распаковалось без ошибок
+ [121278] автоматизированное обновление: проверка имени архитектуры в файлах собственных обновлений и обновлений агентов
- [125959] подвисание AMConsole при запуске агента, если агент слишком долго стартует

--- 5.2.105 --- 18.05.2016
- [129480] загрузка обновлений: не правильно перезаписывался существующий uploading-файл
+ [129480] улучшена диагностика ошибок копирования/переименования файлов

--- 5.2.104 --- 11.04.2016
- [126003] обработка структурных исключений (не работала в 5.2.103)
- [127825] улучшен алгоритм сбора диагностической информации (раньше на некоторых машинах выдавал ошибку 'Cannot get thread context: Access is denied')
- [127825] улучшена диагностика зависаний/ошибок иногда возникающих в процессе автоматизированного обновления
- [127826] linux: ошибка 'open(.../asmo/server/doc) => Is a directory' в процессе автоматизированного обновления
+ [127826] автоматизированное обновление: минимальная версия распаковщика, ограничение перечня распаковываемых файлов (.updateinfo)
+ [127846] автоматизированное обновление: распаковка во временный каталог с последующим переносом/заменой исполняемых файлов

--- 5.2.103 --- 23.03.2016
- [126003] обработка структурных исключений

--- 5.2.102 --- 02.03.2016
- [126252] linux: ошибка при распаковке обновления am

--- 5.2.101 --- 08.02.2016
- [124055] плавающая ошибка 'Агент "..." убит' из-за зависания агентов в процессе остановки

--- 5.2.100 --- 28.01.2016
! [117025] поддержка множества пользователей, поддержка прав доступа (ro, rw)
- [125791] использование каталога run вместо temp

--- 5.2.20 --- 11.12.2015
- [123868] возможность приоставить процесс агента, не реагирующий на ARQ_TERMINATE_AGENT

--- 5.2.19 --- 23.11.2015
- [123377] ошибки, возникающие при запуске агентов, могли приводить к аварийной остановке сборщика телеметрии

--- 5.2.18 --- 17.11.2015
- [122001] восстановлен алгоритм создания слушающих сокетов (как в 5.1)

--- 5.2.17 --- 12.11.2015
+ [120889,112361] linux: автоматизированное обновление/перезапуск через amconsole

--- 5.2.16 --- 09.11.2015
- [122459] улучшена диагностика ошибки 'Socket operation on non-socket'
- [122469] linux: время в логах выводилось с точностью только до секунды (миллисекунды всегда были 000)

--- 5.2.15 --- 06.11.2015
- [122438] ошибка 'All pipe instances are busy' при запуске второго экземпляра одного и того же агента

--- 5.2.14 --- 06.11.2015
+ [122001] улучшена диагностика зависания потока обработки событий
- [122001,120588] убрано неявное отключение tcp-autotuning для всех сокетов

--- 5.2.13 --- 22.10.2015
- [121722] linux: --daemon теперь не пытается создать pid-файл
! [121278] linux: теперь для запуска агентов используется файл pha, а не pha64 (нужно удалить старые версии агентов из каталога updates/agents и очистить каталог temp)

--- 5.2.12 --- 12.10.2015
! [120601] linux: адаптация исходников, скрипт сборки
- [120890] linux: восстановлена поддержка отправки сообщений по xmpp
- [120954] linux: не правильно определялось количество использованной памяти на сервере
! [120669] обновления клиентов теперь ищутся в каталоге ./updates/clients/
- [120730] диагностика проверки существования процесса агента
- [121408] передача агенту пути своего корневого каталога (в аргументе home.path)

--- 5.2.11 --- 21.09.2015
- [120352] crc: Получать имя .exe не из args[0], Более точная диагностика, в каком месте не удалось подсчитать суммы

--- 5.2.10 --- 17.09.2015
+ [120308] логи: получение правильного размера лога и содержимого его частей, если лог больше 4ГБ
- [118691] при запуске агента 5.1 не копировал обновлённый phaXX.conf в каталог агента
- [120514] ошибка 'All pipe instances are busy' из-за утечки системных ресурсов при неудачном запуске агента

--- 5.2.08 --- 11.09.2015
- [119752] каталоги web-root (реальный) и files (в am.ini) переименованы в icons
+ [120131] обновления агентов: поддержка команды повторного чтения каталога

--- 5.2.07 --- 09.06.2015
! [117212] теперь выдаётся ошибка при старте агента, если отсутствует файл phaXX.conf

--- 5.2.06 --- 29.05.2015
- [116627] изменение имени работающего агента, применялось только после остановки агента

--- 5.2.05 --- 18.05.2015
+ [115042] поддержка сверхдлительных операций агента
- [116341] amconsole считала am заблокированным, если есть хотя бы один заблокированный агент

--- 5.2.04 --- 13.05.2015
+ [104663] контроль портов агентов
+ [112361] обновление через amconsole
- [115317] av: при перезагрузке, во время подбора работающих агентов, если у агента не задан id
